#ifndef lint
static const char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif

#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYPATCH 20101229

#define YYEMPTY        (-1)
#define yyclearin      (yychar = YYEMPTY)
#define yyerrok        (yyerrflag = 0)
#define YYRECOVERING() (yyerrflag != 0)

#define YYPREFIX "yy"

#define YYPURE 0

#line 2 "cfg_y.y"
/* cfg.y - configuration language */

/* Written 1995-1999 by Werner Almesberger, EPFL-LRC/ICA */

#if HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <limits.h>
#include <stdlib.h>

#include "atm.h"
#include "atmd.h"

#include "proto.h"
#include "io.h"
#include "trace.h"
#include "policy.h"


static RULE *rule;
static SIG_ENTITY *curr_sig = &_entity;

void yyerror(const char *s);
void yywarn(const char *s);
int yylex(void);

static int hex2num(char digit)
{
    if (isdigit(digit)) return digit-'0';
    if (islower(digit)) return toupper(digit)-'A'+10;
    return digit-'A'+10;
}


static void put_address(char *address)
{
    char *mask;

    mask = strchr(address,'/');
    if (mask) *mask++ = 0;
    if (text2atm(address,(struct sockaddr *) &rule->addr,sizeof(rule->addr),
      T2A_SVC | T2A_WILDCARD | T2A_NAME | T2A_LOCAL) < 0) {
	yyerror("invalid address");
	return;
    }
    if (!mask) rule->mask = -1;
    else rule->mask = strtol(mask,NULL,10);
    add_rule(rule);
}

#line 58 "cfg_y.y"
#ifdef YYSTYPE
#undef  YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
#endif
#ifndef YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
typedef union {
    int num;
    char *str;
    struct sockaddr_atmpvc pvc;
} YYSTYPE;
#endif /* !YYSTYPE_IS_DECLARED */
#line 87 "cfg_y.c"
/* compatibility with bison */
#ifdef YYPARSE_PARAM
/* compatibility with FreeBSD */
# ifdef YYPARSE_PARAM_TYPE
#  define YYPARSE_DECL() yyparse(YYPARSE_PARAM_TYPE YYPARSE_PARAM)
# else
#  define YYPARSE_DECL() yyparse(void *YYPARSE_PARAM)
# endif
#else
# define YYPARSE_DECL() yyparse(void)
#endif

/* Parameters sent to lex. */
#ifdef YYLEX_PARAM
# define YYLEX_DECL() yylex(void *YYLEX_PARAM)
# define YYLEX yylex(YYLEX_PARAM)
#else
# define YYLEX_DECL() yylex(void)
# define YYLEX yylex()
#endif

/* Parameters sent to yyerror. */
#define YYERROR_DECL() yyerror(const char *s)
#define YYERROR_CALL(msg) yyerror(msg)

extern int YYPARSE_DECL();

#define TOK_LEVEL 257
#define TOK_DEBUG 258
#define TOK_INFO 259
#define TOK_WARN 260
#define TOK_ERROR 261
#define TOK_FATAL 262
#define TOK_SIG 263
#define TOK_UNI30 264
#define TOK_UNI31 265
#define TOK_UNI40 266
#define TOK_Q2963_1 267
#define TOK_SAAL 268
#define TOK_VC 269
#define TOK_IO 270
#define TOK_MODE 271
#define TOK_USER 272
#define TOK_NET 273
#define TOK_SWITCH 274
#define TOK_VPCI 275
#define TOK_ITF 276
#define TOK_PCR 277
#define TOK_TRACE 278
#define TOK_POLICY 279
#define TOK_ALLOW 280
#define TOK_REJECT 281
#define TOK_ENTITY 282
#define TOK_DEFAULT 283
#define TOK_NUMBER 284
#define TOK_MAX_RATE 285
#define TOK_DUMP_DIR 286
#define TOK_LOGFILE 287
#define TOK_QOS 288
#define TOK_FROM 289
#define TOK_TO 290
#define TOK_ROUTE 291
#define TOK_PVC 292
#define YYERRCODE 256
static const short yylhs[] = {                           -1,
    0,    4,    4,    5,    5,    6,    6,    6,    6,    6,
    6,   14,    7,   13,   13,   15,   15,   16,   16,   16,
   16,   16,   16,    8,    8,   19,   19,    9,    9,   21,
   21,   10,   10,   23,   23,   11,   11,   25,   25,   12,
   12,   27,   27,   18,   18,   18,   18,   18,   18,   18,
   18,   20,   22,   22,   22,   22,   22,   24,   24,   24,
   24,    2,    2,    1,    1,    1,    1,    1,   17,   17,
   17,   26,   29,   26,    3,    3,   28,   28,
};
static const short yylen[] = {                            2,
    2,    0,    2,    0,    2,    2,    2,    2,    2,    2,
    2,    0,    4,    0,    3,    0,    2,    4,    2,    1,
    1,    1,    1,    1,    3,    0,    2,    1,    3,    0,
    2,    1,    3,    0,    2,    1,    3,    0,    2,    1,
    3,    0,    2,    2,    4,    1,    1,    1,    1,    1,
    2,    2,    2,    2,    2,    1,    1,    2,    1,    1,
    2,    0,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    2,    0,    3,    1,    1,    1,    1,
};
static const short yydefred[] = {                         0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   64,
   65,   66,   67,   68,    6,    0,    0,   59,   60,    0,
   10,   36,    0,   46,   47,   48,   49,    0,   50,    0,
    0,    7,   24,    0,    0,    8,   28,    0,    0,    0,
   57,   56,    0,    9,   32,    0,   75,   76,    0,   73,
   11,   40,    0,    1,    0,    3,   58,   63,   61,    0,
    0,   44,   69,   70,   71,   51,    0,    0,    0,   52,
    0,    0,   53,   54,   55,    0,    0,   72,    0,    0,
    0,   12,    5,   39,   37,    0,   27,   25,   31,   29,
   35,   33,   43,   41,   77,   78,   74,    0,   45,    0,
   13,    0,    0,   23,   21,   20,   22,    0,    0,   19,
    0,   15,   17,    0,   18,
};
static const short yydgoto[] = {                          7,
   15,   59,   50,    8,   54,    9,   55,   32,   36,   44,
   21,   51,  101,   98,  108,  109,   66,   68,   69,   71,
   72,   76,   77,   60,   61,   79,   80,   97,   81,
};
static const short yysindex[] = {                      -214,
 -238, -119, -115, -118, -123, -117,    0, -273, -214,    0,
    0,    0,    0,    0,    0, -238, -266,    0,    0, -245,
    0,    0, -238,    0,    0,    0,    0, -258,    0, -255,
 -196,    0,    0, -238, -246,    0,    0, -238, -262, -253,
    0,    0, -250,    0,    0, -238,    0,    0, -244,    0,
    0,    0, -247,    0, -273,    0,    0,    0,    0, -245,
  -91,    0,    0,    0,    0,    0, -237, -196,  -78,    0,
 -246,  -77,    0,    0,    0, -250,  -74,    0, -244,  -73,
 -264,    0,    0,    0,    0, -231,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  -68,    0, -225,
    0, -258, -227,    0,    0,    0,    0,  -66, -225,    0,
 -212,    0,    0, -222,    0,
};
static const short yyrindex[] = {                         2,
    0,    0,    0,    0,    0,    0,    0,   67,    2,    0,
    0,    0,    0,    0,    0,    0,    1,    0,    0,  -53,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  -52,    0,    0,    0,  -51,    0,    0,    0,    0,    0,
    0,    0,  -49,    0,    0,    0,    0,    0,  -47,    0,
    0,    0,    0,    0,   67,    0,    0,    0,    0,  -53,
    0,    0,    0,    0,    0,    0,    0,  -52,    0,    0,
  -51,    0,    0,    0,    0,  -49,    0,    0,  -47,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    3,    0,  -45,
    0,    0,    0,    0,    0,    0,    0,    0,  -45,    0,
    0,    0,    0,    0,    0,
};
static const short yygindex[] = {                         0,
   -6,    0,    0,   72,   27,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  -26,    0,  -18,   82,   18,   83,
   17,   84,   14,   89,   32,   87,   15,    0,    0,
};
#define YYTABLESIZE 288
static const short yytable[] = {                         43,
   62,    2,   14,   20,   35,   49,   38,   31,   53,   57,
   34,   16,   46,   63,   64,   65,   62,   58,   39,   10,
   11,   12,   13,   14,   95,   96,   40,   70,   67,   74,
   75,   73,   17,   85,   41,   47,   48,   42,   86,   78,
   18,   19,    1,    2,   82,  102,   88,   90,    3,  103,
   92,   94,   99,    4,  100,    5,  111,  104,  112,  105,
   23,  115,  106,  114,    6,  107,    4,   24,   25,   26,
   27,   38,   26,   30,   28,   34,   29,   42,   30,   16,
   56,   83,  113,  110,   33,   87,   37,   89,   45,   91,
   22,   84,   52,   93,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   62,    0,    0,    0,    0,
    0,    0,    0,   38,    0,    0,    0,   16,   34,   46,
    0,   23,    0,    0,    0,   39,    0,    0,   24,   25,
   26,   27,    0,   40,    0,   28,    0,   29,   17,   30,
    0,   41,   47,   48,   42,    0,   18,   19,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   62,   62,    0,
    0,    0,    0,   62,    0,    0,    0,    0,   62,    0,
   62,    0,    0,    0,    0,    0,    0,    0,   62,   62,
    0,    0,   62,    2,   14,    0,   62,   62,
};
static const short yycheck[] = {                        123,
    0,    0,    0,  123,  123,  123,  257,  123,  282,   16,
  257,  257,  257,  272,  273,  274,   23,  284,  269,  258,
  259,  260,  261,  262,  289,  290,  277,   34,  284,  292,
  284,   38,  278,  125,  285,  280,  281,  288,  276,   46,
  286,  287,  257,  258,  292,  271,  125,  125,  263,  275,
  125,  125,  284,  268,  123,  270,  284,  283,  125,  285,
  257,  284,  288,  276,  279,  291,    0,  264,  265,  266,
  267,  125,  125,  125,  271,  125,  273,  125,  275,  125,
    9,   55,  109,  102,    3,   68,    4,   71,    5,   76,
    2,   60,    6,   79,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  125,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  257,   -1,   -1,   -1,  257,  257,  257,
   -1,  257,   -1,   -1,   -1,  269,   -1,   -1,  264,  265,
  266,  267,   -1,  277,   -1,  271,   -1,  273,  278,  275,
   -1,  285,  280,  281,  288,   -1,  286,  287,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,   -1,
   -1,   -1,   -1,  263,   -1,   -1,   -1,   -1,  268,   -1,
  270,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  278,  279,
   -1,   -1,  282,  282,  282,   -1,  286,  287,
};
#define YYFINAL 7
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 292
#if YYDEBUG
static const char *yyname[] = {

"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,"'{'",0,"'}'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"TOK_LEVEL","TOK_DEBUG",
"TOK_INFO","TOK_WARN","TOK_ERROR","TOK_FATAL","TOK_SIG","TOK_UNI30","TOK_UNI31",
"TOK_UNI40","TOK_Q2963_1","TOK_SAAL","TOK_VC","TOK_IO","TOK_MODE","TOK_USER",
"TOK_NET","TOK_SWITCH","TOK_VPCI","TOK_ITF","TOK_PCR","TOK_TRACE","TOK_POLICY",
"TOK_ALLOW","TOK_REJECT","TOK_ENTITY","TOK_DEFAULT","TOK_NUMBER","TOK_MAX_RATE",
"TOK_DUMP_DIR","TOK_LOGFILE","TOK_QOS","TOK_FROM","TOK_TO","TOK_ROUTE",
"TOK_PVC",
};
static const char *yyrule[] = {
"$accept : all",
"all : global local",
"global :",
"global : item global",
"local :",
"local : entity local",
"item : TOK_LEVEL level",
"item : TOK_SIG sig",
"item : TOK_SAAL saal",
"item : TOK_IO io",
"item : TOK_DEBUG debug",
"item : TOK_POLICY policy",
"$$1 :",
"entity : TOK_ENTITY TOK_PVC $$1 opt_options",
"opt_options :",
"opt_options : '{' options '}'",
"options :",
"options : option options",
"option : TOK_VPCI TOK_NUMBER TOK_ITF TOK_NUMBER",
"option : TOK_MODE mode",
"option : TOK_QOS",
"option : TOK_MAX_RATE",
"option : TOK_ROUTE",
"option : TOK_DEFAULT",
"sig : sig_item",
"sig : '{' sig_items '}'",
"sig_items :",
"sig_items : sig_item sig_items",
"saal : saal_item",
"saal : '{' saal_items '}'",
"saal_items :",
"saal_items : saal_item saal_items",
"io : io_item",
"io : '{' io_items '}'",
"io_items :",
"io_items : io_item io_items",
"debug : debug_item",
"debug : '{' debug_items '}'",
"debug_items :",
"debug_items : debug_item debug_items",
"policy : policy_item",
"policy : '{' policy_items '}'",
"policy_items :",
"policy_items : policy_item policy_items",
"sig_item : TOK_LEVEL level",
"sig_item : TOK_VPCI TOK_NUMBER TOK_ITF TOK_NUMBER",
"sig_item : TOK_UNI30",
"sig_item : TOK_UNI31",
"sig_item : TOK_UNI40",
"sig_item : TOK_Q2963_1",
"sig_item : TOK_NET",
"sig_item : TOK_MODE mode",
"saal_item : TOK_LEVEL level",
"io_item : TOK_LEVEL level",
"io_item : TOK_VC TOK_PVC",
"io_item : TOK_PCR TOK_NUMBER",
"io_item : TOK_QOS",
"io_item : TOK_MAX_RATE",
"debug_item : TOK_LEVEL level",
"debug_item : TOK_DUMP_DIR",
"debug_item : TOK_LOGFILE",
"debug_item : TOK_TRACE opt_trace_size",
"opt_trace_size :",
"opt_trace_size : TOK_NUMBER",
"level : TOK_DEBUG",
"level : TOK_INFO",
"level : TOK_WARN",
"level : TOK_ERROR",
"level : TOK_FATAL",
"mode : TOK_USER",
"mode : TOK_NET",
"mode : TOK_SWITCH",
"policy_item : TOK_LEVEL level",
"$$2 :",
"policy_item : action $$2 direction",
"action : TOK_ALLOW",
"action : TOK_REJECT",
"direction : TOK_FROM",
"direction : TOK_TO",

};
#endif
/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH  500
#endif
#endif

#define YYINITSTACKSIZE 500

int      yydebug;
int      yynerrs;

typedef struct {
    unsigned stacksize;
    short    *s_base;
    short    *s_mark;
    short    *s_last;
    YYSTYPE  *l_base;
    YYSTYPE  *l_mark;
} YYSTACKDATA;
int      yyerrflag;
int      yychar;
YYSTYPE  yyval;
YYSTYPE  yylval;

/* variables for the parser stack */
static YYSTACKDATA yystack;

#if YYDEBUG
#include <stdio.h>		/* needed for printf */
#endif

#include <stdlib.h>	/* needed for malloc, etc */
#include <string.h>	/* needed for memset */

/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(YYSTACKDATA *data)
{
    int i;
    unsigned newsize;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = data->stacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = data->s_mark - data->s_base;
    newss = (short *)realloc(data->s_base, newsize * sizeof(*newss));
    if (newss == 0)
        return -1;

    data->s_base = newss;
    data->s_mark = newss + i;

    newvs = (YYSTYPE *)realloc(data->l_base, newsize * sizeof(*newvs));
    if (newvs == 0)
        return -1;

    data->l_base = newvs;
    data->l_mark = newvs + i;

    data->stacksize = newsize;
    data->s_last = data->s_base + newsize - 1;
    return 0;
}

#if YYPURE || defined(YY_NO_LEAKS)
static void yyfreestack(YYSTACKDATA *data)
{
    free(data->s_base);
    free(data->l_base);
    memset(data, 0, sizeof(*data));
}
#else
#define yyfreestack(data) /* nothing */
#endif

#define YYABORT  goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR  goto yyerrlab

int
YYPARSE_DECL()
{
    int yym, yyn, yystate;
#if YYDEBUG
    const char *yys;

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;
    yystate = 0;

#if YYPURE
    memset(&yystack, 0, sizeof(yystack));
#endif

    if (yystack.s_base == NULL && yygrowstack(&yystack)) goto yyoverflow;
    yystack.s_mark = yystack.s_base;
    yystack.l_mark = yystack.l_base;
    yystate = 0;
    *yystack.s_mark = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = YYLEX) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack))
        {
            goto yyoverflow;
        }
        yystate = yytable[yyn];
        *++yystack.s_mark = yytable[yyn];
        *++yystack.l_mark = yylval;
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;

    yyerror("syntax error");

    goto yyerrlab;

yyerrlab:
    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yystack.s_mark]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yystack.s_mark, yytable[yyn]);
#endif
                if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack))
                {
                    goto yyoverflow;
                }
                yystate = yytable[yyn];
                *++yystack.s_mark = yytable[yyn];
                *++yystack.l_mark = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yystack.s_mark);
#endif
                if (yystack.s_mark <= yystack.s_base) goto yyabort;
                --yystack.s_mark;
                --yystack.l_mark;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = YYEMPTY;
        goto yyloop;
    }

yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    if (yym)
        yyval = yystack.l_mark[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);
    switch (yyn)
    {
case 5:
#line 88 "cfg_y.y"
	{
	    if (!curr_sig->uni)
		curr_sig->uni =
#if defined(UNI30) || defined(DYNAMIC_UNI)
		  S_UNI30
#endif
#ifdef UNI31
		  S_UNI31
#ifdef ALLOW_UNI30
		  | S_UNI30
#endif
#endif
#ifdef UNI40
		  S_UNI40
#ifdef Q2963_1
		  | S_Q2963_1
#endif
#endif
		  ;
	}
break;
case 6:
#line 112 "cfg_y.y"
	{
	    set_verbosity(NULL,yystack.l_mark[0].num);
	}
break;
case 12:
#line 124 "cfg_y.y"
	{
	    SIG_ENTITY *sig,**walk;

	    if (atmpvc_addr_in_use(_entity.signaling_pvc))
		yyerror("can't use  io vc  and  entity ...  in the same "
		  "configuration");
	    if (entities == &_entity) entities = NULL;
	    for (sig = entities; sig; sig = sig->next)
		if (atm_equal((struct sockaddr *) &sig->signaling_pvc,
		  (struct sockaddr *) &yystack.l_mark[0].pvc,0,0))
		    yyerror("duplicate PVC address");
	    curr_sig = alloc_t(SIG_ENTITY);
	    *curr_sig = _entity;
	    curr_sig->signaling_pvc = yystack.l_mark[0].pvc;
	    curr_sig->next = NULL;
	    for (walk = &entities; *walk; walk = &(*walk)->next);
	    *walk = curr_sig;
	}
break;
case 18:
#line 155 "cfg_y.y"
	{
	    enter_vpci(curr_sig,yystack.l_mark[-2].num,yystack.l_mark[0].num);
	}
break;
case 20:
#line 160 "cfg_y.y"
	{
	    curr_sig->sig_qos = yystack.l_mark[0].str;
	}
break;
case 21:
#line 164 "cfg_y.y"
	{
	    curr_sig->max_rate = yystack.l_mark[0].num;
	}
break;
case 22:
#line 168 "cfg_y.y"
	{
	     struct sockaddr_atmsvc addr;
	     char *mask;

	    mask = strchr(yystack.l_mark[0].str,'/');
	    if (mask) *mask++ = 0;
	    if (text2atm(yystack.l_mark[0].str,(struct sockaddr *) &addr,sizeof(addr),
	    T2A_SVC | T2A_WILDCARD | T2A_NAME | T2A_LOCAL) < 0) {
		yyerror("invalid address");
		YYABORT;
	    }
	    add_route(curr_sig,&addr,mask ? strtol(mask,NULL,10) : INT_MAX);
	}
break;
case 23:
#line 182 "cfg_y.y"
	{
	    add_route(curr_sig,NULL,0);
	}
break;
case 44:
#line 234 "cfg_y.y"
	{
	    set_verbosity("UNI",yystack.l_mark[0].num);
	    set_verbosity("KERNEL",yystack.l_mark[0].num);
	    set_verbosity("SAP",yystack.l_mark[0].num);
	}
break;
case 45:
#line 240 "cfg_y.y"
	{
	    enter_vpci(curr_sig,yystack.l_mark[-2].num,yystack.l_mark[0].num);
	}
break;
case 46:
#line 244 "cfg_y.y"
	{
#if defined(UNI30) || defined(ALLOW_UNI30) || defined(DYNAMIC_UNI)
	    if (curr_sig->uni & ~S_UNI31) yyerror("UNI mode is already set");
	    curr_sig->uni |= S_UNI30;
#else
	    yyerror("Sorry, not supported yet");
#endif
	}
break;
case 47:
#line 253 "cfg_y.y"
	{
#if defined(UNI31) || defined(ALLOW_UNI30) || defined(DYNAMIC_UNI)
	    if (curr_sig->uni & ~S_UNI30) yyerror("UNI mode is already set");
	    curr_sig->uni |= S_UNI31;
#else
	    yyerror("Sorry, not supported yet");
#endif
	}
break;
case 48:
#line 262 "cfg_y.y"
	{
#if defined(UNI40) || defined(DYNAMIC_UNI)
	    if (curr_sig->uni) yyerror("UNI mode is already set");
	    curr_sig->uni = S_UNI40;
#else
	    yyerror("Sorry, not supported yet");
#endif
	}
break;
case 49:
#line 271 "cfg_y.y"
	{
#if defined(Q2963_1) || defined(DYNAMIC_UNI)
	    if (!(curr_sig->uni & S_UNI40)) yyerror("Incompatible UNI mode");
	    curr_sig->uni |= S_Q2963_1;
#else
	    yyerror("Sorry, not supported yet");
#endif
	}
break;
case 50:
#line 280 "cfg_y.y"
	{
	    yywarn("sig net  is obsolete, please use  sig mode net  instead");
	    curr_sig->mode = sm_net;
	}
break;
case 52:
#line 289 "cfg_y.y"
	{
	    set_verbosity("SSCF",yystack.l_mark[0].num);
	    set_verbosity("SSCOP",yystack.l_mark[0].num);
	}
break;
case 53:
#line 297 "cfg_y.y"
	{
	    set_verbosity("IO",yystack.l_mark[0].num);
	}
break;
case 54:
#line 301 "cfg_y.y"
	{
	    curr_sig->signaling_pvc = yystack.l_mark[0].pvc;
	}
break;
case 55:
#line 305 "cfg_y.y"
	{
	    yywarn("io pcr  is obsolete, please use  io qos  instead");
	    curr_sig->sig_pcr = yystack.l_mark[0].num;
	}
break;
case 56:
#line 310 "cfg_y.y"
	{
	    curr_sig->sig_qos = yystack.l_mark[0].str;
	}
break;
case 57:
#line 314 "cfg_y.y"
	{
	    curr_sig->max_rate = yystack.l_mark[0].num;
	}
break;
case 58:
#line 321 "cfg_y.y"
	{
	    set_verbosity(NULL,yystack.l_mark[0].num);
	}
break;
case 59:
#line 325 "cfg_y.y"
	{
	    dump_dir = yystack.l_mark[0].str;
	    if (!trace_size) trace_size = DEFAULT_TRACE_SIZE;
	}
break;
case 60:
#line 330 "cfg_y.y"
	{
	    set_logfile(yystack.l_mark[0].str);
	}
break;
case 61:
#line 334 "cfg_y.y"
	{
	    trace_size = yystack.l_mark[0].num;
	}
break;
case 62:
#line 340 "cfg_y.y"
	{
	    yyval.num = DEFAULT_TRACE_SIZE;
	}
break;
case 63:
#line 344 "cfg_y.y"
	{
	    yyval.num = yystack.l_mark[0].num;
	}
break;
case 64:
#line 351 "cfg_y.y"
	{
	    yyval.num = DIAG_DEBUG;
	}
break;
case 65:
#line 355 "cfg_y.y"
	{
	    yyval.num = DIAG_INFO;
	}
break;
case 66:
#line 359 "cfg_y.y"
	{
	    yyval.num = DIAG_WARN;
	}
break;
case 67:
#line 363 "cfg_y.y"
	{
	    yyval.num = DIAG_ERROR;
	}
break;
case 68:
#line 367 "cfg_y.y"
	{
	    yyval.num = DIAG_FATAL;
	}
break;
case 69:
#line 374 "cfg_y.y"
	{
	    curr_sig->mode = sm_user;
	}
break;
case 70:
#line 378 "cfg_y.y"
	{
	    curr_sig->mode = sm_net;
	}
break;
case 71:
#line 382 "cfg_y.y"
	{
	    curr_sig->mode = sm_switch;
	}
break;
case 72:
#line 389 "cfg_y.y"
	{
	    set_verbosity("POLICY",yystack.l_mark[0].num);
	}
break;
case 73:
#line 393 "cfg_y.y"
	{
	    rule = alloc_t(RULE);
	    rule->type = yystack.l_mark[0].num;
	}
break;
case 75:
#line 402 "cfg_y.y"
	{
	    yyval.num = ACL_ALLOW;
	}
break;
case 76:
#line 406 "cfg_y.y"
	{
	    yyval.num = ACL_REJECT;
	}
break;
case 77:
#line 413 "cfg_y.y"
	{
	    rule->type |= ACL_IN;
	    put_address(yystack.l_mark[0].str);
	}
break;
case 78:
#line 418 "cfg_y.y"
	{
	    rule->type |= ACL_OUT;
	    put_address(yystack.l_mark[0].str);
	}
break;
#line 947 "cfg_y.c"
    }
    yystack.s_mark -= yym;
    yystate = *yystack.s_mark;
    yystack.l_mark -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yystack.s_mark = YYFINAL;
        *++yystack.l_mark = yyval;
        if (yychar < 0)
        {
            if ((yychar = YYLEX) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yystack.s_mark, yystate);
#endif
    if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack))
    {
        goto yyoverflow;
    }
    *++yystack.s_mark = (short) yystate;
    *++yystack.l_mark = yyval;
    goto yyloop;

yyoverflow:
    yyerror("yacc stack overflow");

yyabort:
    yyfreestack(&yystack);
    return (1);

yyaccept:
    yyfreestack(&yystack);
    return (0);
}
